/**
 * @(#)DBConn.java        2.00 2002/05/26
 * 
 * Copyright (c) 2002-2003 http://www.kimho.pe.kr 
 * All rights reserved. 
 */ 

/** 
 * <p> 
 * kimhoboard v2.0 DB Ŀؼ  Ŭ ̴. 
 * </p> 
 * 
 * <p> 
 * The rights of this class is reserved by http://www.kimho.pe.kr
 * </p> 
 * 
 * @version 2.00 
 * @author  Ho Kim
 */ 

package kr.pe.kimho.conn;

import java.io.*;
import java.util.*;
import java.sql.*;
import kr.pe.kimho.conn.*;

public class DBConn {

	protected DBConnectionManager connMgr = null;
	protected Connection conn = null;
	protected Statement stmt = null;
	protected PreparedStatement pstmt = null;
	protected ResultSet rs = null;

    private Statement test_stmt = null;  // Ȯο ̴..
    private ResultSet test_rs = null;      // ...stmt rs

    protected String db = "mysql";
    protected String hexToStr = "N";

    public DBConn() {
        InputStream is = getClass().getResourceAsStream("/config/db.properties");
		Properties dbProps = new Properties();
        try {
            dbProps.load(is);
        }
        catch (Exception e) {
            System.err.println("properties ã  ϴ. " +
                "db.properties  Ŭн ȮϽñ ٶϴ.");
            return;
        }
        db = dbProps.getProperty("db", "oracle");
        hexToStr = dbProps.getProperty("hexToStr", "N");
    }

	/** Connection  */
	public void dbConn() throws SQLException {
        connMgr = DBConnectionManager.getInstance();
		conn = connMgr.getConnection(db);
        if(db.equals("oracle")) {
            stmt=conn.createStatement(rs.TYPE_SCROLL_SENSITIVE, rs.CONCUR_READ_ONLY);
        } else {
    		stmt=conn.createStatement();
        }
	}

	/**  Ŭ conn  */
	public Connection getConn() {
		return conn;
	}

	public void createStmt() throws SQLException {
        if(db.equals("oracle")) {
            stmt=conn.createStatement(rs.TYPE_SCROLL_SENSITIVE, rs.CONCUR_READ_ONLY);
        } else {
    		stmt=conn.createStatement();
        }
	}

	public void preparedStmt(String sql) throws SQLException {
		pstmt=conn.prepareStatement(sql);
	}

	/** Connection ݳ */
	public void freeConn() throws SQLException {

        try {
            String sql;
            if(db.equals("oracle")) {
                sql = "select sysdate from dual";
            } else if(db.equals("mysql")) {
                sql = "select now()";
            } else {
                sql = "select now()";
            }
            test_stmt = conn.createStatement();
            test_rs = test_stmt.executeQuery(sql);
            if(test_rs.next()) {
                if(stmt!=null) stmt.close();
                if(pstmt!=null) pstmt.close();
                connMgr.freeConnection(db, conn);
            } else {
                conn.close();
                connMgr.freeConnection(db, conn);
            }
        } catch(Exception e) {
            conn.close();
            connMgr.freeConnection(db, conn);
        }
	}

    public void release() {
        connMgr.release();
    }

	/** ResultSet next() */
	public void setNext(String s) throws SQLException {
		rs.next();
	}

	public boolean next() throws SQLException {
		return rs.next();
	}

	public boolean wasNull() throws SQLException {
		return rs.wasNull();
	}

	public boolean isLast() throws SQLException {
		return rs.isLast();
	}

	public int getRow() throws SQLException {
		return rs.getRow();
	}

	/** stmt.executeQuery */
	public void executeQuery(String sql) throws SQLException {
		rs=stmt.executeQuery(sql);
	}

	/** pstmt.exeucteQuery */
	public void pExecuteQuery() throws SQLException {
			rs=pstmt.executeQuery();			
	}

	/** insert, update, delete */
	public void executeUpdate(String sql) throws SQLException {
		stmt.executeUpdate(sql);
	}

	/** insert, update, delete 2 */
	public void pExecuteUpdate() throws SQLException {
		pstmt.executeUpdate();
	}

	/** getString Method */
	public String getString(String field) throws SQLException, IOException {
        if (hexToStr.equals("Y")) {
            return getStringHtoS(field);
        } else {
            String str = rs.getString(field);
            if (str!=null)	{
                return str;
            } else {
                return "";
            }
        }
	}

	/** getInt Method 
    * getInt hexToStr  .Conversion to binary stream failed 
    */
	public int getInt(int i) throws SQLException, IOException {
        //if (hexToStr.equals("Y")) {
        //    return getIntHtoS(i);
        //} else {
    		int in = rs.getInt(i);
	    	return in;
        //}
	}

	public int getInt(String str) throws SQLException, IOException {
        //if (hexToStr.equals("Y")) {
        //    return getIntHtoS(str);
        //} else {
    		int in = rs.getInt(str);
	    	return in;
        //}
	}

	/**  rs  */
	public ResultSet getRs() {
		return rs;
	}

	public void rsListQuery(String sql,int abpage) throws SQLException {
		executeQuery(sql);
		if(next()) {
			rs.absolute(abpage);
		} else {
			rs=null;
		}
	}

	/** rs ݱ */
	public void rsClose() throws SQLException {
		rs.close();
	}

    public String getStringHtoS(String str) throws SQLException,IOException {
        InputStream in = rs.getBinaryStream(str); 
        if(in==null) {
            return "";
        } else {
            int nRead; 
            StringBuffer data = new StringBuffer(); 
            while (true) { 
                byte[] buf = new byte[1024]; 
                nRead = in.read(buf); 
                if (nRead <= 0) break; 
                data.append(new String(buf,"UTF8")); 
            } 
            return data.toString();
        }
    }

    public int getIntHtoS(int i) throws SQLException,IOException {
        InputStream in = rs.getBinaryStream(i); 
        int nRead; 
        StringBuffer data = new StringBuffer(); 
        while (true) { 
            byte[] buf = new byte[1024]; 
            nRead = in.read(buf); 
            if (nRead <= 0) break; 
            data.append(new String(buf,"UTF8")); 
        } 
        return Integer.parseInt(data.toString());
    }

    public int getIntHtoS(String str) throws SQLException,IOException {
        InputStream in = rs.getBinaryStream(str); 
        int nRead; 
        StringBuffer data = new StringBuffer(); 
        while (true) { 
            byte[] buf = new byte[1024]; 
            nRead = in.read(buf); 
            if (nRead <= 0) break; 
            data.append(new String(buf,"UTF8")); 
        } 
        return Integer.parseInt(data.toString());
    }

}
